% Use the PPdata
OpenAddress = 'C:\Users\magic\Desktop\Plasma Brain\Data v10f\PostProcess vf\';
SaveAddress = 'C:\Users\magic\Desktop\Plasma Brain\Data v10f\PostProcess vf\';
WinningNum = zeros(22,2,3);
for  i = 1:22
    for r = 1:500
        his = boardhis(:,:,:,r,i);
        for b = 9:-1:1
            if mean(mean(his(:,:,b))) ~= 0
                finalboard = squeeze(his(:,:,b));
                break;
            end
        end
        victory = findvictory(finalboard);
        WinningNum(i,ceil(mod((r+1),2))+1,victory+1) = WinningNum(i,ceil(mod((r+1),2))+1,victory+1)+1;
    end
end
figure('Position',[10,200,1500,500]);
%colororder({'b','r'});
%figure();
subplot(1,2,1);
yyaxis left;
plot(itaxis,scorehis(1:RS,1),'LineWidth',0.5,'Color','b');
%hold on;
%plot(itaxis,movmean(scorehis(1:RS,1),20),...
%    'LineWidth',1,'Color','b','LineStyle','-');
%hold off;
ylabel('Score of Version 1');
set(gca,'ycolor','b');
yyaxis right;
plot(itaxis,PMhis(1:RS,1),'LineWidth',0.5,'Color','r');
ylabel('Probability of Making the Best Move');
%hold on;
%plot(itaxis,movmean(PMhis(1:RS,1),20),...
%    'LineWidth',1,'Color','r','LineStyle','-');
%hold off;
xlabel('Iteration');
set(gca,'ycolor','r');
grid on;
xlim([0,450]);
set(gca,'FontSize',14);
subplot(1,2,2);
TPPT = [1;2;3;4;5;6;7;8;9;10;20;30;40;50;60;70;80;90;100;200;300;450];
lw = 0.1;
pow = 1;
hold on;
scatter(TPPT,WinningNum(:,1,2)/250,'s','b');
p = polyfit(log10(TPPT),WinningNum(:,1,2)/250,pow);
y = polyval(p,log10(TPPT));
plot(TPPT,y,'--','Color','b','LineWidth',lw);
scatter(TPPT,WinningNum(:,1,3)/250,'s','r');
p = polyfit(log10(TPPT),WinningNum(:,1,3)/250,pow);
y = polyval(p,log10(TPPT));
plot(TPPT,y,'--','Color','r','LineWidth',lw);
scatter(TPPT,WinningNum(:,1,1)/250,[],[0.5,0,0.5],'s');
p = polyfit(log10(TPPT),WinningNum(:,1,1)/250,pow);
y = polyval(p,log10(TPPT));
plot(TPPT,y,'--','Color',[0.5,0,0.5],'LineWidth',lw);
scatter(TPPT,WinningNum(:,2,2)/250,'d','b');
p = polyfit(log10(TPPT),WinningNum(:,2,2)/250,pow);
y = polyval(p,log10(TPPT));
plot(TPPT,y,'-.','Color','b','LineWidth',lw);
scatter(TPPT,WinningNum(:,2,3)/250,'d','r');
p = polyfit(log10(TPPT),WinningNum(:,2,3)/250,pow);
y = polyval(p,log10(TPPT));
plot(TPPT,y,'-.','Color','r','LineWidth',lw);
scatter(TPPT,WinningNum(:,2,1)/250,[],[0.5,0,0.5],'d');
p = polyfit(log10(TPPT),WinningNum(:,2,1)/250,pow);
y = polyval(p,log10(TPPT));
plot(TPPT,y,'-.','Color',[0.5,0,0.5],'LineWidth',lw);
scatter(TPPT,(WinningNum(:,1,2)+WinningNum(:,2,2))/500,'filled','o','b');
p = polyfit(log10(TPPT),(WinningNum(:,1,2)+WinningNum(:,2,2))/500,pow);
y = polyval(p,log10(TPPT));
plot(TPPT,y,'Color','b','LineWidth',1);
scatter(TPPT,(WinningNum(:,1,3)+WinningNum(:,2,3))/500,'filled','o','r');
p = polyfit(log10(TPPT),(WinningNum(:,1,3)+WinningNum(:,2,3))/500,pow);
y = polyval(p,log10(TPPT));
plot(TPPT,y,'Color','r','LineWidth',1);
scatter(TPPT,(WinningNum(:,1,1)+WinningNum(:,2,1))/500,[],[0.5,0,0.5],'filled','o');
p = polyfit(log10(TPPT),(WinningNum(:,1,1)+WinningNum(:,2,1))/500,pow);
y = polyval(p,log10(TPPT));
plot(TPPT,y,'Color',[0.5,0,0.5],'LineWidth',1);
hold off;
set(gca,'XScale','log');
xlim([0,600]);
set(gca,'FontSize',14);
grid on;
xlabel('Iteration');
ylabel('Winning Rate');

function victory = findvictory(board)
victory = 0;
for x = 1:3
    for y = 1:3
        if x == 2
            if y == 2
                if (board(x-1,y-1) == board(x,y)) && (board(x+1,y+1) == board(x,y))
                    victory = board(x,y);
                end
                if (board(x+1,y-1) == board(x,y)) && (board(x-1,y+1) == board(x,y))
                    victory = board(x,y);
                end
                if (board(x+1,y) == board(x,y)) && (board(x-1,y) == board(x,y))
                    victory = board(x,y);
                end
                if (board(x,y-1) == board(x,y)) && (board(x,y+1) == board(x,y))
                    victory = board(x,y);
                end
            else
                if (board(x+1,y) == board(x,y)) && (board(x-1,y) == board(x,y))
                    victory = board(x,y);
                end
            end
        end
        if y == 2
            if (board(x,y-1) == board(x,y)) && (board(x,y+1) == board(x,y))
                victory = board(x,y);
            end
        end
        if victory ~= 0
            break;
        end
    end
    if victory ~= 0
        break;
    end
end
end